#!/usr/bin/perl -w
#
# shinGETsu - P2P anonymous BBS
#
# (c) Fuktommy <fuktommy@users.sourceforge.net>
# Released under the GNU General Public License
# $Id: note.cgi,v 1.7 2004/09/22 14:18:52 fuktommy Exp $
#
use strict;
use lib qw(..);
use Shingetsu::Config;
use Shingetsu::Cache;
use Shingetsu::CacheStat;
use Shingetsu::Gateway;

umask $Shingetsu::Config::umask;

my $datadir	= $Shingetsu::Config::datadir;
my $cachedir	= $Shingetsu::Config::cachedir;
my $root	= $Shingetsu::Config::root;
my @types	= qw(list thread note);
my $message	= $Shingetsu::Gateway::message;

#
# print note
#
sub printNote($) {
	my($note) = @_;
	local $_;
	$note = escape($note);
	my $file_note = file_encode("note", $note);
	touch($file_note);
	printHeader($note);
	my($buf, $conflict) = readNote($file_note);
	my %rec = rec($buf);
	$rec{body} = "" unless (defined $rec{body});
	my $body = html_format($rec{body});
	print "\n<p>$body</p>\n";
	print "<p><em>$$message{conflict}</em></p>" if ($conflict);
	my $filesize = int((-s "$datadir/$file_note.dat")/1024/1024*10)/10;
	if ($filesize <= $Shingetsu::Config::filelimit) {
		print "<form method='post' action='$ENV{SCRIPT_NAME}'><p>",
		"<input type='hidden' name='cmd' value='add' />",
		"<input type='hidden' name='file' value='$file_note' />",
		"<input type='submit' value='$$message{add}' name='submit' tabindex='1' accesskey='w' />",
		" <input type='checkbox' value='dopost' name='dopost'",
		" checked='checked' tabindex='2' accesskey='s' />",
		"$$message{send}",
		" <input type='checkbox' value='error' name='error'",
		" checked='checked' tabindex='2' accesskey='e' />",
		"$$message{error}<br />",
		"<textarea rows='5' cols='70' name='message' tabindex='8' accesskey='c'></textarea>",
		"<br /><a href='$ENV{SCRIPT_NAME}/", str_encode($note), "?mode=edit'>$$message{edit}</a>",
		" | <a href='$ENV{SCRIPT_NAME}/", str_encode($note), "?mode=history'>$$message{history}</a>",
		"</p></form>";
	} else {
		print "<p><a href='$ENV{SCRIPT_NAME}/note/", str_encode($note), "?mode=history'>$$message{history}</a></p>";
	}
	print "<form method='get' action='$ENV{SCRIPT_NAME}'>",
	      "<p><input type='submit' value='$$message{del_file}' tabindex='9' accesskey='d' />",
	      "<input type='hidden' name='cmd' value='delete' />",
	      "<input type='hidden' name='file' value='$file_note' />",
	      " ${filesize}$$message{mb}</p></form></body></html>\n";
}

#
# edit form
#
sub editForm($$) {
	my($file, $rec) = @_;
	my $body = (defined $$rec{body})? $$rec{body}: "";
	$body =~ s|<br>|\n|g;
	print "<form method='post' action='$ENV{SCRIPT_NAME}'><p>",
	      "<input type='hidden' name='cmd' value='post' />",
	      "<input type='hidden' name='file' value='$file' />",
	      "<input type='submit' value='$$message{post}' name='submit' tabindex='1' accesskey='w' />",
	      " <input type='checkbox' value='dopost' name='dopost'",
	      " checked='checked' tabindex='2' accesskey='s' />",
	      "$$message{send}",
	      " <input type='checkbox' value='error' name='error'",
	      " checked='checked' tabindex='2' accesskey='e' />",
	      "$$message{error}<br />",
	      "<textarea rows='20' cols='75' name='body' tabindex='8' accesskey='c'>$body</textarea>",
	      "<input type='hidden' value='$$rec{stamp}' name='base_stamp' />",
	      "<input type='hidden' value='$$rec{id}' name='base_id' />",
	      "</p></form>";
}

#
# print note history
#
sub printHistory($$) {
	my($name, $type) = @_;
	local $_;
	$name = escape($name);
	my $file = file_encode($type, $name);
	touch($file);
	open IN, "$cachedir/$file/body.cache"
			or open IN, "$datadir/$file.dat";
	printHeader($name);
	print "<form method='get' action='$ENV{SCRIPT_NAME}'>",
	      "<p><input type='hidden' name='cmd' value='delete' />",
	      "<input type='hidden' name='file' value='$file' /></p><dl>\n";
	my @buf = <IN>;
	my %ref = ();
	my $last = "";
	foreach (@buf) {
		my %rec = rec($_);
		next if (keys %rec <= 2);
		$ref{"$rec{stamp}_$rec{id}"} = 0;
		if (! $rec{base_stamp}) {
			$ref{"$rec{stamp}_$rec{id}"} = 1;
			next;
		} elsif (defined $ref{"$rec{base_stamp}_$rec{base_id}"}) {
			$ref{"$rec{base_stamp}_$rec{base_id}"}++;
		}
		$last = $_;
	}
	if ($last) {
		my %rec = rec($last);
		$ref{"$rec{stamp}_$rec{id}"} = 1;
	}
	my $last_record;
	foreach (@buf) {
		my %rec = rec($_);
		next if (keys %rec <= 2);
		my $xstamp = xlocaltime $rec{stamp};
		$rec{body} = "" if (! defined $rec{body});
		$rec{body} = html_format($rec{body});
		my $base = "";
		if ($rec{base_id}) {
			$base = substr $rec{base_id}, 0, 8;
			$base =~ s/"/&quot;/g;
			$base = "(<a href=\"#r$base\">&gt;&gt;$base</a>)" if ($base);
		}
		my $remove = "";
		if (($rec{remove_id}) && ($rec{remove_stamp})) {
			my $xid = substr($rec{remove_id},0,8);
			$remove = "[[$$message{remove}: <a href='#r$xid'>$xid</a>]]<br />";
		}
		my $xid = substr $rec{id}, 0, 8;
		my $conflict = ($ref{"$rec{stamp}_$rec{id}"})? "": " <em>$$message{conflict}</em>";
		print "<dt id='r$xid'><input type='radio' name='record' value='$rec{stamp}/$rec{id}' ",
		      "tabindex='1' accesskey='s' />",
		      "$xid $xstamp $base$conflict</dt><dd>$rec{body}<br />$remove<br /></dd>\n";
	}
	close IN;
	print "</dl><p><input type='submit' value='$$message{del_record}' tabindex='2' accesskey='d' />",
      	      "<input type='hidden' name='mode' value='$type' /></p></form>";
	my($buf, $conflict) = readNote($file);
	my %rec = rec($buf);
	editForm($file, \%rec);
	my $filesize = int((-s "$datadir/$file.dat")/1024/1024*10)/10;
	print "<form method='get' action='$ENV{SCRIPT_NAME}'>",
	      "<p><input type='submit' value='$$message{del_file}' tabindex='9' accesskey='d' />",
	      "<input type='hidden' name='cmd' value='delete' />",
	      "<input type='hidden' name='file' value='$file' />",
	      " ${filesize}$$message{mb}</p></form></body></html>\n";
}

#
# edit dialog
#
sub editDialog($$) {
	my($name, $type) = @_;
	$name = escape($name);
	my $file = file_encode($type, $name);
	touch($file);
	my($buf, $conflict) = readNote($file);
	my %rec = rec($buf);
	$rec{body} = "" unless (defined $rec{body});
	my $xbody = html_format($rec{body});
	printHeader($name);
	print "\n<p>$xbody</p>\n";
	print "<p><em>$$message{conflict}</em></p>" if ($conflict);	
	editForm($file, \%rec);
	my $filesize = int((-s "$datadir/$file.dat")/1024/1024*10)/10;
	print "<form method='get' action='$ENV{SCRIPT_NAME}'>",
	      "<p><input type='submit' value='$$message{del_file}' tabindex='9' accesskey='d' />",
	      "<input type='hidden' name='file' value='$file' />",
	      "<input type='hidden' name='cmd' value='delete' />",
	      " ${filesize}$$message{mb}</p></form></body></html>\n";
}


#
# main routine
#
my ($path, $input) = readQuery();
my %arg = args($input);

my $cmd = ($arg{cmd})? $arg{cmd}: "";
my $file = ($arg{file})? $arg{file}: "";
my $record = ($arg{record})? $arg{record}: "";

if (($cmd eq "post") && ($file =~ /^note_[0-9A-F]+/)) {
	my $id = post($file, %arg);
	print302("${root}note.cgi/" . str_encode(file_decode($file)));

} elsif (($cmd eq "add") && ($file =~ /^note_[0-9A-F]+/)) {
	margeRecord($file, %arg);
	print302("${root}note.cgi/" . str_encode(file_decode($file)));

} elsif ($cmd eq "delete") {
	checkAdmin();
	deleteDialog(%arg);

} elsif (($cmd eq "xdelete")
		&& ($ENV{HTTP_REFERER} =~ m{^http://[^/]+/(list|thread|note)\.cgi\?cmd=delete})) {
	checkAdmin();
	if (! defined $arg{file}) {
		print404();
		exit;
	} elsif ((defined $arg{stamp})&&(defined $arg{id})) {
		deleteRecord($arg{file}, $arg{stamp}, $arg{id}, \%arg);
	} else {
		deleteFile($arg{file});
	}

} elsif (($path ne "") && ($path !~ m|/|)) { 
	if ((! defined $arg{mode}) || ($arg{mode} eq "")) {
		printNote($path);
	} elsif ($arg{mode} eq "edit") {
		editDialog($path, "note");
	} elsif ($arg{mode} eq "history") {
		printHistory($path, "note");
	} else {
		printNote($path);
	}

} else {
	print404();
	exit;
}
